Global iniLines
Global iniCmd$[512]
Global iniParm$[512]
GetINI()

Global ScreenWidth=512	; ScreenWidth=FromINI(ScreenWidth,"Screen Width","Sheet Width")
Global ScreenHeight=512	; ScreenHeight=FromINI(ScreenHeight,"Screen Height","Sheet Height")
Global SpriteWidth=64	; SpriteWidth=FromINI(SpriteWidth,"Sprite Size","Size","Sprite Width","Width")
Global SpriteHeight=64	; SpriteHeight=FromINI(SpriteHeight,"Sprite Size","Size","Sprite Height","Height")


Global Rescale=0
	Temp$=Upper$(FromINItxt$("","Rescale","Make"))
	If temp$="TRUE" Or temp$="LARGER" Or temp$="BIGGER" Or temp$="GROW" Then Rescale=2
	If temp$="SMALLER" Or temp$="SHRINK" Then Rescale=1
	
Global OutFilename$="Out"	;	OutFilename$=FromINItxt$(OutFilename$,"Filename","Save As","Output")
outfilename$=Replace(outfilename$,"/","_")
outfilename$=Replace(outfilename$,"\","_")
outfilename$=Replace(outfilename$,";","_")
outfilename$=Replace(outfilename$,":","_")
outfilename$=Replace(outfilename$,"*","_")
outfilename$=Replace(outfilename$,"?","_")
outfilename$=Replace(outfilename$,"!","_")
outfilename$=Replace(outfilename$,Chr$(34),"")


Global MaskColor=$FF00FF


Global SpritesX=Floor(ScreenWidth/SpriteWidth)
Global SpritesY=Floor(ScreenHeight/SpriteHeight)

Function GetIni()
	iniLines=0
If FileType("settings.ini")=1	
	DebugLog "Found ini file"
	quickin=ReadFile("settings.ini")
	lines=0
	Repeat
		intxt$=ReadLine(quickin)
		If Instr(intxt,"=")
			cmd$=iniLeft$(intxt)
			parm$=iniRight(intxt)
			cmd=Trim$(cmd$)
			cmd=Replace$(cmd," ","")
			cmd=Lower$(cmd)
			parm$=Trim$(parm$)
			
			iniLines=iniLines+1
			iniCmd[iniLines]=cmd$
			iniParm[iniLines]=parm$
		EndIf
		
		If iniLines>500 Then fin=1
		If Eof(quickin) Then fin=1
	Until fin=1
	CloseFile quickin
EndIf
End Function

Function FromINI(value,va$="-1",vb$="-1",vc$="-1",vd$="-1",ve$="-1",vf$="-1",vg$="-1")
Local fout=value
va$=Lower$(Trim$(Replace$(va$," ","")))
vb$=Lower$(Trim$(Replace$(vb$," ","")))
vc$=Lower$(Trim$(Replace$(vc$," ","")))
vd$=Lower$(Trim$(Replace$(vd$," ","")))
ve$=Lower$(Trim$(Replace$(ve$," ","")))
vf$=Lower$(Trim$(Replace$(vf$," ","")))
vg$=Lower$(Trim$(Replace$(vg$," ","")))

For inie=1 To iniLines
	If va$=inicmd[inie] Then fout=Int(iniparm[inie])
	If vb$=inicmd[inie] Then fout=Int(iniparm[inie])
	If vc$=inicmd[inie] Then fout=Int(iniparm[inie])
	If vd$=inicmd[inie] Then fout=Int(iniparm[inie])
	If ve$=inicmd[inie] Then fout=Int(iniparm[inie])
	If vf$=inicmd[inie] Then fout=Int(iniparm[inie])
	If vg$=inicmd[inie] Then fout=Int(iniparm[inie])
Next

Return fout
End Function


Function FromINItxt$(value$,va$="-1",vb$="-1",vc$="-1",vd$="-1",ve$="-1",vf$="-1",vg$="-1")
Local fout$=value
va$=Lower$(Trim$(Replace$(va$," ","")))
vb$=Lower$(Trim$(Replace$(vb$," ","")))
vc$=Lower$(Trim$(Replace$(vc$," ","")))
vd$=Lower$(Trim$(Replace$(vd$," ","")))
ve$=Lower$(Trim$(Replace$(ve$," ","")))
vf$=Lower$(Trim$(Replace$(vf$," ","")))
vg$=Lower$(Trim$(Replace$(vg$," ","")))

For inie=1 To iniLines
	If va$=inicmd[inie] Then fout=iniparm[inie]
	If vb$=inicmd[inie] Then fout=iniparm[inie]
	If vc$=inicmd[inie] Then fout=iniparm[inie]
	If vd$=inicmd[inie] Then fout=iniparm[inie]
	If ve$=inicmd[inie] Then fout=iniparm[inie]
	If vf$=inicmd[inie] Then fout=iniparm[inie]
	If vg$=inicmd[inie] Then fout=iniparm[inie]
Next

Return fout
End Function



Function SplitText$(in$,Split$,e,alsospace=0)

	'Splits text...
	Local out:String=""
	Local start:Int=1
	Local nomore:Int=0
	Local shift:Int
	Local size:Int

	in:String=Trim(in)
	e=e-1
	
	For shift=1 To e
		If Instr(in$,Split$,start)+1<=nstart Then nomore=1
		If Instr(in$,Split$,start)+1>nstart Then nstart=Instr(in$,Split$,start)+1
		If AlsoSpace=1 Then If Instr(in$," ",start)+1<nstart And Instr(in$," ",start)>0 Then nstart=Instr(in$," ",start)+1
		start=nstart
	Next
	size=(Instr(in$,Split$,start))-start
	If AlsoSpace=1 Then If (Instr(in$," ",start))-start<size And Instr(in$," ",start)>0 Then size=(Instr(in$," ",start))-start
	

	out$=Mid$(in$,start,size)
	If nomore=1 Then out$="-+-"
	Return out
End Function

Function IniLeft$(ftxt$)
	Return Upper$(Trim$(splittext$(ftxt$,"=",1,0)))
End Function

Function IniRight$(ftxt$)
	Return Trim$(splittext$(ftxt$,"=",2,0))
End Function


Function Ink(ang#,bright#)
	Local fr#=(80+(Cos(ang)*200.0))*bright
	Local fg#=(80+(Cos(ang+240)*200.0))*bright
	Local fb#=(80+(Cos(ang+120)*200.0))*bright
	
	If fr<0 Then fr=0
	If fr>255 Then fr=255
	If fgr<0 Then fg=0
	If fg>255 Then fg=255
	If fb<0 Then fb=0
	If fb>255 Then fb=255
	SetColor(fr,fg,fb)
End Function

Function InkLight(ang#,bright#)
	Local fr#=(180+(Cos(ang)*100.0))*bright
	Local fg#=(180+(Cos(ang+240)*100.0))*bright
	Local fb#=(180+(Cos(ang+120)*100.0))*bright
	
	If fr<0 Then fr=0
	If fr>255 Then fr=255
	If fgr<0 Then fg=0
	If fg>255 Then fg=255
	If fb<0 Then fb=0
	If fb>255 Then fb=255
	SetColor(fr,fg,fb)
End Function


Function ResetDraw()
SetRotation 0
SetAlpha(1)
SetColor(255,255,255)
SetBlend(ALPHABLEND)
End Function

Graphics ScreenWidth,ScreenHeight
Global SpriteX,SpriteY
Global w,h
w=SpriteWidth;h=SpriteHeight
SeedRnd(MilliSecs());For n=0 To 100;r=Rnd(0,10);Next

Repeat
Cls

For SpriteY=0 To SpritesY-1
For SpriteX=0 To SpritesX-1
ResetDraw()
SetViewport(SpriteX*SpriteWidth,SpriteY*SpriteHeight,SpriteWidth,SpriteHeight)
SetOrigin(SpriteX*SpriteWidth,SpriteY*SpriteHeight)
w=SpriteWidth;h=SpriteHeight
SetColor((MaskColor & $FF0000) Shr 16,(MaskColor & $00FF00) Shr 8,(MaskColor & $0000FF))
DrawRect(dx,dy,w,h)

ResetDraw()
Generator()


SetViewport(0,0,ScreenWidth,ScreenHeight)
SetOrigin(0,0)
Flip
Next
Next

outimg=GrabPixmap(0,0,ScreenWidth,ScreenHeight)
For x=0 To ScreenWidth-1
For y=0 To ScreenHeight-1
	argb=ReadPixel(outimg,x,y)
	If (argb & $00FFFFFF)=MaskColor Then argb=$00000000
	WritePixel(outimg,x,y,argb)
Next
Next

If Rescale=0
	SavePixmapPNG(outimg,OutFilename+".png")
EndIf

If Rescale=1
	SavePixmapPNG(outimg,OutFilename+"-hd2.png")
	outimg_2=ResizePixmap(outimg,ScreenWidth/2,ScreenHeight/2)
	SavePixmapPNG(outimg_2,OutFilename+"-hd.png")
	outimg_1=ResizePixmap(outimg,ScreenWidth/4,ScreenHeight/4)
	SavePixmapPNG(outimg_1,OutFilename+".png")
EndIf

If Rescale=2
	SavePixmapPNG(outimg,OutFilename+".png")
	outimg_2=CreatePixmap(ScreenWidth*2,ScreenHeight*2,PF_RGBA8888)
	outimg_4=CreatePixmap(ScreenWidth*4,ScreenHeight*4,PF_RGBA8888)
	
	For x=0 To ScreenWidth-1
	For y=0 To ScreenHeight-1
		argb=ReadPixel(outimg,x,y)
	
		WritePixel(outimg_2,x*2,y*2,argb)
		WritePixel(outimg_2,x*2,y*2+1,argb)
		WritePixel(outimg_2,x*2+1,y*2,argb)
		WritePixel(outimg_2,x*2+1,y*2+1,argb)

		For ex=0 To 3
		For ey=0 To 3
			WritePixel(outimg_4,x*4+ex,y*4+ey,argb)
		Next
		Next
		
	Next
	Next
	
	SavePixmapPNG(outimg_2,OutFilename+"-hd.png")
	SavePixmapPNG(outimg_4,OutFilename+"-hd2.png")
EndIf

DrawText("Finished : Press any key to Quit",4,ScreenHeight-14)
Flip
WaitKey()
Until Not KeyDown(KEY_R)

' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
' Generator code goes below!
' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Function Generator()

FlowerStyle=Rand(1,4)

PetalInk=Rand(0,360)

CenterInk=PetalInk+120
If Rnd(0,10)<5 Then CenterInk=PetalInk-120

Size#=Rnd((w/4),(w/2)-6)
CenterSize#=Rnd(w/8,Size*0.4)
PetalBright#=Rnd(0.9,1.1)

Local order#[256]

Select FlowerStyle
	Case 1	' Daisy - Lots of thin petals, Yellowy center
		split#=Rnd(16,48)
		gap#=360.0/split
		trot#=Rnd(0,360)
		For m=0 To split
			order[m]=m
		Next
		For m=0 To split
			r=Rand(0,split)
			t=order[m]
			order[m]=order[r]
			order[r]=t
		Next
		
		For m=0 To split
			DrawPetalLight(300/split,(Float(order[m])*gap)+trot,Rnd(-1,1)+Size,PetalInk,PetalBright)
		Next
		
		For rot=0 To 3600
		For dist=0 To CenterSize*10
			bright=255-(Float(dist)/4.0)
			If bright<150 Then bright=150
			If bright>255 Then bright=255
			SetColor(bright,Rand(bright-50,bright-100),Rand(0,bright-100))
			Plot (w/2)+Sin(Float(rot)/10.0)*(Float(dist)/10.0),(h/2)-Cos(Float(rot)/10.0)*(Float(dist)/10.0)
		Next
		Next
		
	Case 2	' Poppy - Thick petals, Black center	
		split#=Rnd(5,10)
		gap#=360.0/split
		trot#=Rnd(0,360)
		
		For m=0 To split
			order[m]=m
		Next
		For m=0 To split
			r=Rand(0,split)
			t=order[m]
			order[m]=order[r]
			order[r]=t
		Next
		
		For m=0 To split
			DrawPetal(300/split,(Float(order[m])*gap)+trot,Rnd(-1,1)+Size,PetalInk,PetalBright)
		Next
		
		For rot=0 To 3600
		For dist=0 To CenterSize*10
			bright=Rand(60,80)-(Float(dist))
			If bright<2 Then bright=2
			If bright>80 Then bright=80
			SetColor(bright,bright,bright)
			Plot (w/2)+Sin(Float(rot)/10.0)*(Float(dist)/10.0),(h/2)-Cos(Float(rot)/10.0)*(Float(dist)/10.0)
		Next
		Next

	Case 3	' Poppish - Thick petals, Two layers, Alt center
		split#=Rnd(5,10)
		gap#=360.0/split
		PetalBright=Rnd(0.85,1.0)
		trot#=Rnd(0,360)
		For m=0 To split
			order[m]=m
		Next
		For m=0 To split
			r=Rand(0,split)
			t=order[m]
			order[m]=order[r]
			order[r]=t
		Next
		
		For m=0 To split
			DrawPetal(300/split,(Float(order[m])*gap)+trot,Rnd(-1,1)+Size,PetalInk,PetalBright)
		Next

		trot#=Rnd(0,360)

'		PetalBright=Rnd(0.6,0.8)
		Size=Size*Rnd(0.7,0.9)
		For m=0 To split
			order[m]=m
		Next
		For m=0 To split
			r=Rand(0,split)
			t=order[m]
			order[m]=order[r]
			order[r]=t
		Next
		
		For m=0 To split
			DrawPetal(300/split,(Float(order[m])*gap)+trot,Rnd(-1,1)+Size,PetalInk,PetalBright)
		Next
		
		


		For rot=0 To 3600
		For dist=0 To CenterSize*10
			bright=Rand(250)-(Float(dist))
			If bright<150 Then bright=150
			If bright>250 Then bright=250
			Ink(CenterInk,Float(bright)/270.0)
			Plot (w/2)+Sin(Float(rot)/10.0)*(Float(dist)/10.0),(h/2)-Cos(Float(rot)/10.0)*(Float(dist)/10.0)
		Next
		Next



	Case 4	' Rose - Interweaving petals towards center
	
		fdist#=Rnd(Float(w/2)*0.5,Float(w/2)*0.95)
		frot#=Rnd(0,360)
		Repeat
			DrawPetal(Rnd(90,120),frot,fdist,PetalInk,PetalBright)
			frot=frot+Rnd(70,120)
			fdist=fdist-Rnd(Float(w)*0.01,Float(w)*0.025)
		Until fdist<6
	
	
End Select

Delay 50

End Function


Function DrawPetal(width#,rot#,size#,fink#,fdark#=1.0)

For far=10 To 1 Step -1
For r=-(width*10) To (width*10)
	
	dif#=(Float(Abs(r))/10.0)/width
	
	puff#=size-Abs(dif)*8

		darker#=(Float(far)*0.025)+0.75
		darker=Float(far)*0.1
		Ink(fink,(fdark-(dif/5.0))*darker)
		
		dx=Sin((Float(r)/10.0)+rot)*(puff*(Float(far)/10.0))
		dy=-Cos((Float(r)/10.0)+rot)*(puff*(Float(far)/10.0))

		DrawLine(w/2,h/2,Float(w/2)+dx,Float(h/2)+dy)
	Next
Next


End Function ' DrawPetal

Function DrawPetalLight(width#,rot#,size#,fink#,fdark#=1.0)

For far=10 To 1 Step -1
For r=-(width*10) To (width*10)
	
	dif#=(Float(Abs(r))/10.0)/width
	
	puff#=size-Abs(dif)*8

		darker#=(Float(far)*0.025)+0.75
		darker=Float(far)*0.1
		InkLight(fink,(fdark-(dif/5.0))*darker)
		
		dx=Sin((Float(r)/10.0)+rot)*(puff*(Float(far)/10.0))
		dy=-Cos((Float(r)/10.0)+rot)*(puff*(Float(far)/10.0))

		DrawLine(w/2,h/2,Float(w/2)+dx,Float(h/2)+dy)
	Next
Next


End Function ' DrawPetalLight